<?php

define('ATOMNS', 'http://www.w3.org/2005/Atom');
$feed_title = "Example Atom Feed";
$alt_url = "http://www.example.org/";
$feed = "http://www.example.org/atom/";

$doc = new DOMDocument("1.0", "UTF-8");

function create_append_Atom_elements($doc, $name, $value=NULL, $parent=NULL) {
   if ($value)
	   $newelem = $doc->createElementNS(ATOMNS, $name, $value);
	else
	   $newelem = $doc->createElementNS(ATOMNS, $name);
   if ($parent)
      return $parent->appendChild($newelem);
}

try {
   $feed = create_append_Atom_elements($doc, 'feed', NULL, $doc);
   create_append_Atom_elements($doc, 'title', $feed_title, $feed);
   create_append_Atom_elements($doc, 'subtitle', $feed_title, $feed);
   create_append_Atom_elements($doc, 'id', $alt_url, $feed);
   create_append_Atom_elements($doc, 'updated', date('c'), $feed);

   $entry = create_append_Atom_elements($doc, 'entry', NULL, $feed);

   $title = create_append_Atom_elements($doc, 'title', 'My first entry', $entry);
   $title->setAttribute('type', 'text');

   $link = create_append_Atom_elements($doc, 'link', NULL, $entry);
   $link->setAttribute('type', 'text/html');
   $link->setAttribute('rel', 'alternate');
   $link->setAttribute('href', 'http://www.example.org/entry-url');
   $link->setAttribute('title', 'My first entry');

   $author = create_append_Atom_elements($doc, 'author', NULL, $entry);
   create_append_Atom_elements($doc, 'name', 'Rob', $author);

   create_append_Atom_elements($doc, 'id', 'http://www.example.org/entry-guid', $entry);
   create_append_Atom_elements($doc, 'updated', date('c'), $entry);
   create_append_Atom_elements($doc, 'published', date('c'), $entry);

   $content = create_append_Atom_elements($doc, 'content', NULL, $entry);
   $cdata = $doc->createCDATASection('This is my first Atom entry!<br />More to follow');
   $content->appendChild($cdata);

   $doc->formatOutput = TRUE;
   print $doc->saveXML();
} catch (DOMException $e) {
   var_dump($e);
}
?>

