<?php
$doc = new DOMDocument();
print "DTD Validation:\n";
$doc->load('courses-dtd.xml', LIBXML_DTDVALID);
/* No errors means document is valid */

if ($doc->validate()) {
     print "   Document Is Valid\n";
}

print "DTD Validation FAILURE:\n";
$doc->load('course-id.xml');
if ($doc->validate()) {
     print "   Document Is Valid\n";
}

/* Test Failed Validation using Internal Errors */
libxml_use_internal_errors(TRUE);
if ($doc->validate()) {
     print "Document Is Valid\n";
} else {
     $arErrors = libxml_get_errors();
	 foreach ($arErrors AS $xmlError) {
          print $xmlError->message;
     }
}

$doc->load('course.xml');
print "\nXML Schema Validation:\n";
if($doc->schemaValidate('course.xsd')) {
     print "   Document is valid\n";
}

$doc->load('course.xml');
print "\nRelaxNG Validation:\n";
if($doc->relaxNGValidate('course.rng')) {
     print "   Document is valid\n";
}

?>
