<?php
function startElement($parser, $elementname, $attributes) {
  print "* Start Element: $elementname \n";
  foreach ($attributes as $attname => $attvalue) {
    print "   $attname => $attvalue \n";
  }
}

function endElement($parser, $elementname) {
  print "* End Element: $elementname\n";
}

function charDataHandler($parser,$data) {
  if (trim($data) != "") print $data."\n";
}

function PIhandler ($parser, $target, $data) {
    print "PI: $target -> $data\n";
}

function DefaultHandler($parser, $data) {
    print "Default: $data\n";
}

$parser = xml_parser_create();
/* Disable as case is significant in XML */
xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, false);

xml_set_element_handler($parser,"startElement","endElement");
xml_set_character_data_handler($parser, "charDataHandler");
xml_set_processing_instruction_handler ($parser, "PIhandler");
xml_set_default_handler ($parser, "DefaultHandler");

if (($fp = fopen("xml_simple.xml", "r"))) {   
   while ($data = fread($fp, 4096)) {
        xml_parse($parser, $data, feof($fp));
    }
}
?>
