<?php
/* URL to Product Search service */
$url = 'http://api.shopping.yahoo.com/ShoppingService/V1/productSearch';

/* The query is separate here as the terms must be encoded. */
$url .= '?query='.rawurlencode('linksys');

/* Complete the URL with App ID, limit to 1 result and start at second record */
$url .= "&appid=zzz&results=2&start=2";

$reader = new XMLReader();

/* This function is used ONLY when we know element contains only TEXT */
function getTextValue($reader) {
    if ($reader->nodeType != XMLReader::ELEMENT || $reader->isEmptyElement
            || ($reader->read() && $reader->nodeType == XMLReader::END_ELEMENT))
		return;
    $retVal = $reader->value;

    /* Move to END_ELEMENT */
    $reader->read();
	return $retVal;
}

function processCatalog($reader) {
    /* Get current tree depth */
    $depth = $reader->depth;
    /* Print the Catalog ID */
    print "Catalog ID".$reader->getAttribute('ID')."\n";
	
    /* If element is empty <element /> or read() positions on END_ELEMENT then no subtree */
    if ($reader->isEmptyElement || 
            ($reader->read() && $reader->nodeType == XMLReader::END_ELEMENT))
        return;

    /* While within subtree output the designated pieces from the Result tree */
    while($depth < $reader->depth) {
       switch ($reader->name) {
           case "ProductName":
           case "PriceFrom":
           case "PriceTo":	
           case "Description":	
           case "Url":
		       print $reader->name.": ".getTextValue($reader)."\n";
       }
	   /* Skip any subtrees and move to next sibling */
       $reader->next();
    }
}

function processResult($reader) {
    /* Get current tree depth */
    $depth = $reader->depth;
    /* If element is empty <element /> or calling read() positions on END_ELEMENT then no subtree */
    if ($reader->isEmptyElement || ($reader->read() && $reader->nodeType == XMLReader::END_ELEMENT)) return;

    /* While within Result subtree locate Catalog element and Process it */
    while($depth < $reader->depth && $reader->name != "Catalog") { $reader->read(); };
	processCatalog($reader);
	/* Read until </Result> is encountered */
	while($depth < $reader->depth) { $reader->read(); }
}

if (! $reader->open($url)) { print "Cannot access Webservice\n"; exit; }

/* Find the Result Element */
while($reader->name != "Result") { 
   $reader->read();
}

/* Process Result elements */
do {
   processResult($reader);
} while($reader->next('Result'));
?>
