<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:php="http://php.net/xsl" version="1.0">
  <xsl:output method="html"/>
  <xsl:param name="siteid" select="0" />
  <xsl:template match="/">
    <html>
      <body>
        <xsl:apply-templates select="id($siteid)"/>
      </body>
    </html>
  </xsl:template>

  <xsl:template match="/sites/site">
    <xsl:variable name="itemnum" select="php:functionString('initReader', ./url)" />
    <xsl:if test="number($itemnum) > 0">
        <xsl:call-template name="itemproc" />
    </xsl:if>
  </xsl:template>

  <xsl:template match="item">
     <p>
        Title: <b><xsl:value-of select="./title" /></b><br/><br/>
        URL: <xsl:value-of select="./link" /><br/>
        Published: <xsl:value-of select="./pubDate" /><br/>
     </p>
  </xsl:template>

  <xsl:template name="itemproc">
    <xsl:variable name="nodeset" select="php:functionString('readNextItem')" />
    <xsl:if test="boolean($nodeset)">
        <xsl:apply-templates select="$nodeset"/>
        <xsl:call-template name="itemproc" />
    </xsl:if>
  </xsl:template>


</xsl:stylesheet>

